// Generated by CoffeeScript 2.7.0
(function() {
  var I, comp, compress, decomp, decompress, jsonp, plug, zlib;

  zlib = require('zlib');

  plug = function(rs, rj) {
    return function(err, res) {
      if (err) {
        return rj(err);
      } else {
        return rs(res);
      }
    };
  };

  comp = function(buf) {
    return new Promise(function(rs, rj) {
      return zlib.gzip(buf, plug(rs, rj));
    });
  };

  decomp = function(buf) {
    return new Promise(function(rs, rj) {
      return zlib.gunzip(buf, plug(rs, rj));
    });
  };

  jsonp = function(str) {
    return new Promise(function(rs, rj) {
      var err;
      try {
        return rs(JSON.parse(str));
      } catch (error) {
        err = error;
        return rj(err);
      }
    });
  };

  I = function(v) {
    return v;
  };

  compress = function(msg, props) {
    if (props != null ? props.compress : void 0) {
      if (Buffer.isBuffer(msg)) {
        return [
          {
            compress: 'buffer'
          },
          comp(msg)
        ];
      } else {
        return [
          {
            compress: 'json'
          },
          comp(Buffer.from(JSON.stringify(msg)))
        ];
      }
    } else {
      return [null, Promise.resolve(msg)];
    }
  };

  decompress = function(msg, props) {
    var data, ref;
    if (props != null ? props.compress : void 0) {
      data = (ref = msg != null ? msg.data : void 0) != null ? ref : msg;
      if (props.compress === 'buffer') {
        return ['application/octet-stream', decomp(data)];
      } else if (props.compress === 'json') {
        return [
          'application/json',
          decomp(data).then(function(buf) {
            return jsonp(buf.toString());
          })
        ];
      } else {
        return [null, Promise.resolve(msg)];
      }
    } else {
      return [null, Promise.resolve(msg)];
    }
  };

  module.exports = {compress, decompress};

}).call(this);
