// Generated by CoffeeScript 2.7.0
(function() {
  var AmqpClient, Rpc, RpcBackend, log;

  log = require('loglevel').getLogger('amqp');

  AmqpClient = require('./amqp-client');

  Rpc = require('./rpc');

  RpcBackend = require('./rpc-backend');

  // facade that ties together the various pieces
  module.exports = function(conf = {}) {
    return new Promise(function(resolve, reject) {
      var client;
      if (conf.logLevel) {
        // set log level if defined in config
        log.setLevel(conf.logLevel);
      }
      if (!conf.connection) {
        // support old-style configuration
        conf = {
          connection: conf
        };
      }
      client = new AmqpClient(conf);
      return client.connect().then(() => {
        var rpc, rpcBackend;
        rpc = new Rpc(client, conf.rpc);
        rpcBackend = new RpcBackend(client);
        return resolve({
          on: client.on.bind(client),
          exchange: client.exchange,
          queue: client.queue,
          bind: client.bind,
          rpc: rpc.rpc,
          serve: rpcBackend.serve,
          shutdown: client.shutdown
        });
      }).catch(function(err) {
        return reject(err);
      });
    });
  };

  module.exports.RpcError = require('./rpc-error');

}).call(this);
